# Method: projects.locations.documents.patch

Updates a document. Returns INVALID_ARGUMENT if the name of the document is non-empty and does not equal the existing name.

### HTTP request

`PATCH https://contentwarehouse.googleapis.com/v1/{name}`

### Path parameters

| Parameters ||
|---|---|
| `name` | `string` Required. The name of the document to update. Format: projects/{projectNumber}/locations/{location}/documents/{documentId} or projects/{projectNumber}/locations/{location}/documents/referenceId/{referenceId}. It takes the form `projects/{project}/locations/{location}/documents/{document}`. |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "document": { object (`https://docs.cloud.google.com/document-warehouse/docs/reference/rest/v1/Document`) }, "requestMetadata": { object (`https://docs.cloud.google.com/document-warehouse/docs/reference/rest/v1/RequestMetadata`) }, "cloudAiDocumentOption": { object (`https://docs.cloud.google.com/document-warehouse/docs/reference/rest/v1/CloudAIDocumentOption`) }, "updateOptions": { object (`https://docs.cloud.google.com/document-warehouse/docs/reference/rest/v1/UpdateOptions`) } } ``` |

| Fields ||
|---|---|
| `document` | ``object (`https://docs.cloud.google.com/document-warehouse/docs/reference/rest/v1/Document`)`` Required. The document to update. |
| `requestMetadata` | ``object (`https://docs.cloud.google.com/document-warehouse/docs/reference/rest/v1/RequestMetadata`)`` The meta information collected about the end user, used to enforce access control for the service. |
| `cloudAiDocumentOption` | ``object (`https://docs.cloud.google.com/document-warehouse/docs/reference/rest/v1/CloudAIDocumentOption`)`` Request Option for processing Cloud AI Document in Document Warehouse. This field offers limited support for mapping entities from Cloud AI Document to Warehouse Document. Please consult with product team before using this field and other available options. |
| `updateOptions` | ``object (`https://docs.cloud.google.com/document-warehouse/docs/reference/rest/v1/UpdateOptions`)`` options for the update operation. |

### Response body

If successful, the response body contains an instance of `https://docs.cloud.google.com/document-warehouse/docs/reference/rest/v1/UpdateDocumentResponse`.

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://cloud.google.com/docs/authentication/).

### IAM Permissions

Requires the following [IAM](https://cloud.google.com/iam/docs) permission on the `name` resource:

- `contentwarehouse.documents.update`

For more information, see the [IAM documentation](https://cloud.google.com/iam/docs).